<?php
class framework_api_filetmp{
	const SERVER_MAIN = 'filetmp.ga/api/';
	const SERVER_SUB = 'filetmp.cf/api/';
	private static $auth_token = NULL;
	private static $server = framework_api_filetmp::SERVER_MAIN;
	public $debug = false;
	public static function set_server($server) {
		self::$server = $server;
	}
	public static function auth($auth_token) {
		self::$auth_token = $auth_token;
	}
	public function __construct(){
		$this->crypto = "AES-128-ECB";
	}
	private function cURL($url, $post){
		$this->log("Prepare cURL");
		$options = array(
			CURLOPT_CONNECTTIMEOUT => 6000,
			CURLOPT_TIMEOUT	       => 6000,
			CURLOPT_HEADER         => false,
			CURLOPT_FOLLOWLOCATION => true,
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_USERAGENT      => "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.69 Safari/537.36",
			CURLOPT_SSL_VERIFYPEER => false,
			CURLOPT_POST           => true,
			CURLOPT_POSTFIELDS     => $post
		);
		$this->log("cURL url: $url", 'cURL');
		$this->log("cURL options: json=".json_encode($options), 'cURL');
		$ch = curl_init($url);
		curl_setopt_array($ch, $options);
		$result = curl_exec ($ch);
		curl_close ($ch);
		return $result;
	}
	private function download_raw_and_decrypt($tid, $nkey){
		$APItoken = self::$auth_token;
		$server = 'https://' . self::$server;
		$url = $server.'download/';
		$post = array('auth' => $APItoken, 'tid'=> $tid, 't' => 'key');
		$key = $this->cURL($url, $post);
		$post = array('auth' => $APItoken, 'tid'=> $tid, 't' => 'file');
		$file = $this->cURL($url, $post);
		$crypto = $this->crypto;
		$data = openssl_decrypt(base64_encode(openssl_decrypt($file, $crypto, $key), $nkey), $crypto, $key);
		return $data;
	}
	public function download($tid, $key){
		$result = $this->download_raw_and_decrypt($tid, $key);
		$this->log("File downloaded", 'download');
		if(!empty($result)){
			return $result;
		}else{
			$this->log("Could not connect to server; throw Exception", 'download');
			$this->error('download');
			return false;
		}
	}
	public function get_file_info($tid){
		$APItoken = self::$auth_token;
		$server = 'https://' . self::$server;
		$url = $server.'file-info/';
		$post = array('auth' => $APItoken, 'tid'=> $tid);
		$result = $this->cURL($url, $post);
		if(!empty($result)){
			return json_decode($result, true);
		}else{
			$this->log("Could not connect to server; throw Exception", 'get_file_info');
			$this->error('get-info');
			return false;
		}
	}
	public function upload($full_file_path){
		$APItoken = self::$auth_token;
		$server = 'https://' . self::$server;
		$this->log("Checking file $full_file_path is exists");
		if(file_exists($full_file_path)){
			$this->log("File $full_file_path exists, making file send");
			if(function_exists('curl_file_create')){
				$this->log('CURL_FILE_CREATE[EXISTS] => USE CURL FUNCTION');
				$cFile = curl_file_create($full_file_path);
			}else{
				$this->log('CURL_FILE_CREATE[NOT EXISTS] => USE LEGACY FUNCTION');
				$cFile = '@' . realpath($full_file_path);
			}
			$url = $server.'upload/';
			$post = array('auth' => $APItoken, 'file'=> $cFile);
			$result = $this->cURL($url, $post);
			$this->log("Upload Finished :: RESULT = \"$result\"", 'upload');
			return json_decode($result, true);
		}else{
			$this->log("File $full_file_path not exists; throw Exception", 'upload');
			$this->error('upload');
			return false;
		}
	}
	private function error($name){
		if($name == 'upload'){
			throw new Exception('Could not upload file (cannot connect to server).');
		}elseif($name == 'download'){
			throw new Exception('Could not download file (cannot connect to server).');
		}elseif($name == 'get-info'){
			throw new Exception('Could not get file info (cannot connect to server).');
		}else{
			throw new Exception('An Unkown Error.');
		}
	}
	
	/* Log. */
	protected function log($message, $name = 'function') {
		if ($this->debug) {
			echo "[FileTMP_DEBUG][class.filetmp.api.$name] FileTMP::$message\n";
		}
	}
}
?>