<?php
require_once(__DIR__ . '/fw.secure.certificate/fw.secure.certificate.key.php');
require_once(__DIR__ . '/fw.secure.certificate/fw.secure.certificate.sign.php');
require_once(__DIR__ . '/fw.secure.certificate/fw.secure.certificate.verify.php');
class framework_certificate{
	function __construct($certificate){
		$parse = $this->parse($certificate);
		if(!$parse){
			return false;
		}
		$this->parse = $parse;
	}
	function pasre($certificate){
		$str_r = str_replace(["----------BEGIN FWSIGN CERTIFICATE----------","----------END FWSIGN CERTIFICATE----------"],'',$certificate);
		if(base64_encode(base64_decode($str_r, true)) === $str_r){$b64_parsed = base64_decode($str_r);}else{return false;}
		$Cjson = $b64_parsed;
		$decrypt = $this->ccrypt($Cjson);
		if(!json_decode($decrypt,true)){
			return false;
		}else{
			return json_decode($decrypt);
		}
	}
	function create_private_key($bit = 2048){
		$key = '';
		for($x = 0; $x < ($bit / 8); $x++){
			$rand = rand(32, 126);
			$key .= chr($rand);
		}
		return base64_encode($key);
	}
	function private_key_to_public_key($private_key){
		$private_key = str_replace(["----------BEGIN FWSIGN KEY----------","----------END FWSIGN KEY----------"],'',$private_key);
		if(!empty($private_key)){
			if(base64_encode(base64_decode($private_key, true)) === $private_key) $private_key = base64_decode($private_key);
			$key = $this->text2ascii($private_key);
			$keysize = count($key);
			$cipher = "";
			for($i = 0; $i < $keysize; $i++){
				$cipher .= chr($key[$i] ^ $key[$i]);
			}
			return base64_encode($cipher);
		}else{
			return '';
		}
	}
	function decrypt($text, $private_key) {
		$private_key = str_replace(["----------BEGIN FWSIGN KEY----------","----------END FWSIGN KEY----------"],'',$private_key);
		if(!empty($private_key)){
			if(base64_encode(base64_decode($private_key, true)) === $private_key) $private_key = base64_decode($private_key);
			$key = $this->text2ascii($private_key);
			$eak = $this->ekey($key);
			$text = $this->text2ascii($text);
			$keysize = count($key);
			$text_size = count($text);
			$crypt = "";
			for ($i = 0; $i < $text_size; $i++){
				$crypt .= chr($text[$i] ^ ($key[$i % $keysize] ^ $eak));
			}
			return $crypt;
		}else{
			return false;
		}
	}
	function encrypt($text, $public_key) {
		$public_key = str_replace(["----------BEGIN FWSIGN PUBKEY----------","----------END FWSIGN PUBKEY----------"],'',$public_key);
		if(!empty($public_key)){
			if(base64_encode(base64_decode($public_key, true)) === $public_key) $public_key = base64_decode($public_key);
			$key = $this->text2ascii($public_key);
			$eak = $this->ekey($key);
			$text = $this->text2ascii($text);
			$keysize = count($key);
			$text_size = count($text);
			$cipher = "";
			for($i = 0; $i < $text_size; $i++){
				$cipher .= chr($text[$i] ^ $key[$i % $keysize]);
			}
			return $cipher;
		}else{
			return false;
		}
	}
	private function ekey($ascii) {
		$text = 0;
		foreach($ascii as $char){
			$text = $text+$char;
		}
		return $text;
	}
	private function ccrypt($string){
		$key = $this->text2ascii(base64_encode(sha1("FW_CERTIFICATE_CRYPTION")));
		$text = $this->text2ascii($string);
		$keysize = count($key);
		$text_size = count($text);
		$cipher = "";
		for($i = 0; $i < $text_size; $i++){
			$cipher .= chr($text[$i] ^ $key[$i % $keysize]);
		}
		return $cipher;
	}
	private function text2ascii($text){
		return array_map('ord', str_split($text));
	}
}
?>