<?php
class framework_certificate_sign{
	public $e = '';
	public $c = '';
	public $s = '';
	public $cn = '';
	public $o = '';
	public $ou = '';
	public $l = '';
	public $date = 86400*90;
	public $key_sign = 'VSK';
	public $sign_by = 'FW_DEF_SIGN';
	public $key_usage = 'SHA512, RAND_GEN, B64';
	public $special_key_usage = 'NOT_CA, CRYPT_WITH_PASSWORD';
	public $cert_seri = '';
	public $key_seri = '';
	function refresh_req_all(){
		$this->cn = 'FW Sign Certificate-'.base64_encode(rand());
		$this->cert_seri = sha1(base64_encode(md5(rand())));
		$this->key_seri = sha1(rand().chr(rand()));
	}
	function refresh_name(){
		$this->cn = 'FW Sign Certificate-'.base64_encode(rand());
	}
	function refresh_seri($i = null){
		if($i == null){ $n = rand(); }else{ $n = $i; }
		$this->cert_seri = sha1(base64_encode(md5($n)));
	}
	function refresh_key_seri(){
		$this->key_seri = sha1(rand().chr(rand()));
	}
	function sign($trust = false, $key = '', $CAcert = '', $CAkey = ''){
		if(!empty($CAkey)){ $CAkey = sha1($CAkey); }
		if(empty($key)){ $key = $this->create_private_key(512); }
		$public_key = $this->private_key_to_public_key($key);
		if(!$trust){$trust = 'false';}else{$trust = 'true';}
		$main = 
		base64_encode(
			$this->ccrypt(
				json_encode(
					[
						'CN='.$this->cn,
						'E' => $this->e,
						'L' => $this->l,
						'C' => $this->c,
						'S' => $this->s,
						'O' => $this->o,
						'OU' => $this->ou,
						'KEY_SIGN' => $this->key_sign,
						'KEY_SERI' => $this->key_seri,
						'CA_KEY' => sha1($CAkey),
						'T' => $trust,
						'PUBLIC_KEY' => hash('sha512',$public_key),
						'CERTIFICATE_SERI' => $this->cert_seri,
						'createDate' => time(),
						'Expdate' => (time()+$this->date),
						'KEY_USAGE' => $this->key_usage,
						'SPECAL_KEY_USAGE' => $this->special_key_usage,
						'PRIVATE_KEY' => hash('sha512',$key),
						'CA_CERTIFICATE' => $CAcert
					]
				)
			)
		);
		$csr = 
		base64_encode(
			$this->ccrypt(
				json_encode(
					[
						'CN'.$this->cn,
						'E' => $this->e,
						'L' => $this->l,
						'C' => $this->c,
						'S' => $this->s,
						'O' => $this->o,
						'OU' => $this->ou,
						'KEY_SIGN' => $this->key_sign,
						'KEY_SERI' => $this->key_seri,
						'CA_KEY' => sha1($CAkey),
						'Time' => $this->date,
						$this->cert_seri
					]
				)
			)
		);
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
			$r = "\r\n";
		} else {
			$r = "\n";
		}
		$cert = '';
		$z = 0;
		$cac = strlen($main) / 64;
		for($x=0; $x <= $cac;$x++){
			$cert .= substr($main,0+$z,64).$r;
			$z=$z+64;
		}
		$csr_s = '';
		$z = 0;
		$cac = strlen($key) / 64;
		for($x=0; $x <= $cac;$x++){
			$csr_s .= substr($csr,0+$z,64).$r;
			$z=$z+64;
		}
		$key_r = '';
		$z = 0;
		$cac = strlen($csr) / 64;
		for($x=0; $x <= $cac;$x++){
			$key_r .= substr($key,0+$z,64).$r;
			$z=$z+64;
		}
		$pkey_r = '';
		$z = 0;
		$cac = strlen($putenv) / 64;
		for($x=0; $x <= $cac;$x++){
			$pkey_r .= substr($public_key,0+$z,64).$r;
			$z=$z+64;
		}
		return 
				[
					"certificate" => "----------BEGIN FWSIGN CERTIFICATE----------".$r.$cert."----------END FWSIGN CERTIFICATE----------",
					"key" => "----------BEGIN FWSIGN KEY----------".$r.$key_r."----------END FWSIGN KEY----------",
					"key" => "----------BEGIN FWSIGN PUBKEY----------".$r.$pkey_r."----------END FWSIGN PUBKEY----------",
					"csr" => "----------BEGIN FWSIGN REQUEST----------".$r.$csr_s."----------END FWSIGN REQUEST----------"
				];
	}
	function create_private_key($bit = 2048){
		$key = '';
		for($x = 0; $x < ($bit / 8); $x++){
			$rand = rand(32, 126);
			$key .= chr($rand);
		}
		return base64_encode($key);
	}
	function private_key_to_public_key($private_key){
		if(!empty($private_key)){
			if(base64_encode(base64_decode($private_key, true)) === $private_key) $private_key = base64_decode($private_key);
			$key = $this->text2ascii($private_key);
			$keysize = count($key);
			$cipher = "";
			for($i = 0; $i < $keysize; $i++){
				$cipher .= chr($key[$i] ^ $key[$i]);
			}
			return base64_encode($cipher);
		}else{
			return '';
		}
	}
	private function ccrypt($string){
		$key = $this->text2ascii(base64_encode(sha1("FW_CERTIFICATE_CRYPTION")));
		$text = $this->text2ascii($string);
		$keysize = count($key);
		$text_size = count($text);
		$cipher = "";
		for($i = 0; $i < $text_size; $i++){
			$cipher .= chr($text[$i] ^ $key[$i % $keysize]);
		}
		return $cipher;
	}
	private function text2ascii($text){
		return array_map('ord', str_split($text));
	}
}
?>