<?php
class framework_certificate_verify{
	function __construct($certificate){
		$parse = $this->parse($certificate);
		if(!$parse){
			return false;
		}
		$this->parse = $parse;
	}
	function verify_seri($seri){
		$parse = $this->parse;
		if(!$parse){
			return NULL;
		}else{
			if($parse["CERTIFICATE_SERI"] === $seri){
				return true;
			}else{
				return false;
			}
		}
	}
	function verify_key_seri($seri){
		$parse = $this->parse;
		if(!$parse){
			return NULL;
		}else{
			if($parse["KEY_SERI"] === $seri){
				return true;
			}else{
				return false;
			}
		}
	}
	function verify_is_expire(){
		$parse = $this->parse;
		if(!$parse){
			return NULL;
		}else{
			if($parse["Expdate"] <= time()){
				return true;
			}else{
				return false;
			}
		}
	}
	function verify_pubkey($key){
		$parse = $this->parse;
		if(!$parse){
			return NULL;
		}else{
			$str_r = str_replace(["----------BEGIN FWSIGN PUBKEY----------","----------END FWSIGN PUBKEY----------"],'',$key);
			if($parse["PUBLIC_KEY"] == hash('sha512',base64_encode(base64_decode($str_r)))){
				return true;
			}else{
				return false;
			}
		}
	}
	function verify_key($key){
		$parse = $this->parse;
		if(!$parse){
			return NULL;
		}else{
			$str_r = str_replace(["----------BEGIN FWSIGN KEY----------","----------END FWSIGN KEY----------"],'',$key);
			if($parse["PRIVATE_KEY"] == hash('sha512',base64_encode(base64_decode($str_r)))){
				return true;
			}else{
				return false;
			}
		}
	}
	function verify_trust(){
		$parse = $this->parse;
		if(!$parse){
			return NULL;
		}else{
			if($parse["T"] === "true"){
				return true;
			}else{
				return false;
			}
		}
	}
	function pasre($certificate){
		$str_r = str_replace(["----------BEGIN FWSIGN CERTIFICATE----------","----------END FWSIGN CERTIFICATE----------"],'',$certificate);
		if(base64_encode(base64_decode($str_r, true)) === $str_r){
			$b64_parsed = base64_decode($str_r);
		}else{
			return false;
		}
		$Cjson = $b64_parsed;
		$decrypt = $this->ccrypt($Cjson);
		if(!json_decode($decrypt,true)){
			return false;
		}else{
			return json_decode($decrypt);
		}
	}
	private function ccrypt($string){
		$key = $this->text2ascii(base64_encode(sha1("FW_CERTIFICATE_CRYPTION")));
		$text = $this->text2ascii($string);
		$keysize = count($key);
		$text_size = count($text);
		$cipher = "";
		for($i = 0; $i < $text_size; $i++){
			$cipher .= chr($text[$i] ^ $key[$i % $keysize]);
		}
		return $cipher;
	}
	private function text2ascii($text){
		return array_map('ord', str_split($text));
	}
}
?>