<?php
class MNC{
	function __construct(){
		$this->PATTERN = '/(?:\-?\d+\s*(?:\.?\d+\s*)?[\+\-\*\/\^\%])+\-?\d+\s*(?:\.?\d+\s*)?/';
		$this->PARENTHESIS_DEPTH = 10;
		$this->data = [];
		$this->var = [];
		$this->s = 0;
		$this->l = 1;
	}
    private function calculate($input){
        if(strpos($input, '+') != null || strpos($input, '-') != null || strpos($input, '/') != null || strpos($input, '*') != null || strpos($input, '^') != null || strpos($input, '%') != null){
            $input = str_replace(' ', '', $input);
            $input = str_replace(',', '.', $input);
            $input = preg_replace('[^0-9\.\^\%\+\-\*\/\(\)]', '', $input);
            $i = 0;
            while(strpos($input, '(') || strpos($input, ')')){
                $input = preg_replace_callback('/\(([^\(\)]+)\)/', '$this->callback', $input);

                $i++;
                if($i > $this->PARENTHESIS_DEPTH){
                    break;
                }
            }
            if(preg_match($this->PATTERN, $input, $match)){
                return $this->compute($match[0]);
            }
            if(is_numeric($input)){
                return $input;
            }

            return 0;
        }

        return $input;
    }

    private function compute($input){
        $compute = create_function('', 'return '.$input.';');

        return 0 + $compute();
    }

    private function callback($input){
        if(is_numeric($input[1])){
            return $input[1];
        }
        elseif(preg_match($this->PATTERN, $input[1], $match)){
            return $this->compute($match[0]);
        }
        return 0;
    }
	private function replace_var($string, $var, $data){
		foreach($var as $rvar){
			$string = str_replace("VAR:".$rvar.":", $data[$rvar], $string);
		}
		return $string;
	}
	private function execute_code_line($input_line){
		global $argv;
		$data = $this->data;
		$var = $this->var;
		$s = $this->s;
		$l = $this->l;
		$input_line = str_replace(["\r","\n","\r\n"],'',$input_line);
		if(substr($input_line,0,3) === "SET"){
			preg_match('/SET\s*(\w*)\s*=\s*"(.*)"/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				$data[$output_array[1]] = str_replace(["\\n","\\r\\n"],["\n","\r\n"],$output_array[2]);
				$var[$s] = $output_array[1];
				$this->s = $s + 1;
				$this->data = $data;
				$this->var = $var;
				return 0;
			}else{
				die("MNC \"SET\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,3) === "INT"){
			preg_match('/INT\s+(\w+)\s+=\s+([\d]+)/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				$data[$output_array[1]] = (int)$output_array[2];
				$var[$s] = $output_array[1];
				$this->s = $s + 1;
				$this->data = $data;
				$this->var = $var;
				return 0;
			}else{
				die("MNC \"INT\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,4) === "BOOL"){
			preg_match('/BOOL\s+(\w+)\s+=\s+(true|false)/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				if($output_array[2] == "true")
					$data[$output_array[1]] = true;
				else
					$data[$output_array[1]] = false;
				$var[$s] = $output_array[1];
				$this->s = $s + 1;
				$this->data = $data;
				$this->var = $var;
				return 0;
			}else{
				die("MNC \"BOOL\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,8) === "PHP_EXEC"){
			preg_match('/PHP_EXEC\s+"(.*)"/', $input_line, $output_array);
			if(isset($output_array[1])){
				eval($output_array[1]);
				return 0;
			}else{
				die("MNC \"BOOL\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,10) === "FILEDELETE"){
			preg_match('/FILEDELETE\s*"(.*)"/', $input_line, $output_array);
			if(isset($output_array[1])){
				if(file_exists($output_array[1])){
					unlink($output_array[1]);
				}
				return 0;
			}else{
				die("MNC \"FILEDELETE\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,8) === "READLINE"){
			preg_match('/READLINE\s+"(\w+)"/', $input_line, $output_array);
			if(isset($output_array[1])){
				if(!empty($output_array[1])){
					$data[$output_array[1]] = readline();;
					$var[$s] = $output_array[1];
					$this->s = $s + 1;
					$this->data = $data;
					$this->var = $var;
					return 0;
				}else{
					die("MNC \"READLINE\" Syntax Error at line $l\n");
				}
			}else{
				die("MNC \"READLINE\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,9) === "FILEWRITE"){
			preg_match('/FILEWRITE\s+"(.+)"\s+CONTENTS\s+"(.+)"/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				if(!empty($output_array[1])){
					file_put_contents($output_array[1],$this->replace_var($output_array[2],$var,$data));
					return 0;
				}else{
					die("MNC \"FILEWRITE\" Syntax Error at line $l\n");
				}
			}else{
				die("MNC \"FILEWRITE\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,8) === "FILEREAD"){
			preg_match('/FILEREAD\s+"(.+)"\s+VAR\s+(\w+)/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				if(!empty($output_array[1])){
					$data[$output_array[2]] = file_get_contents($output_array[1]);
					$var[$s] = $output_array[2];
					$this->s = $s + 1;
					$this->data = $data;
					$this->var = $var;
					return 0;
				}else{
					die("MNC \"FILEREAD\" Syntax Error at line $l\n");
				}
			}else{
				die("MNC \"FILEREAD\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,3) === "ORD"){
			preg_match('/ORD\s+(\w+)\s+=\s+"(.)"/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				$data[$output_array[1]] = ord($output_array[2]);
				$var[$s] = $output_array[1];
				$this->s = $s + 1;
				$this->data = $data;
				$this->var = $var;
				return 0;
			}else{
				die("MNC \"ORD\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,3) === "CHR"){
			preg_match('/CHR\s+(\w+)\s+=\s+([\d\w\W]+)/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				$data[$output_array[1]] = chr($this->calculate($this->replace_var($output_array[2],$var,$data)));
				$var[$s] = $output_array[1];
				$this->s = $s + 1;
				$this->data = $data;
				$this->var = $var;
				return 0;
			}else{
				die("MNC \"CHR\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,4) === "CALC"){
			preg_match('/CALC\s*(\w*)\s*=\s*(.*)/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				$data[$output_array[1]] = $this->calculate($this->replace_var($output_array[2],$var,$data));
				$var[$s] = $output_array[1];
				$this->s = $s + 1;
				$this->data = $data;
				$this->var = $var;
				return 0;
			}else{
				die("MNC \"CALC\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,7) === "CAL_SIN"){
			preg_match('/CAL_SIN\s*(\w*)\s*=\s*(.*)/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				$data[$output_array[1]] = sin($this->calculate($this->replace_var($output_array[2],$var,$data)));
				$var[$s] = $output_array[1];
				$this->s = $s + 1;
				$this->data = $data;
				$this->var = $var;
				return 0;
			}else{
				die("MNC \"CAL_SIN\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,7) === "CAL_COS"){
			preg_match('/CAL_COS\s*(\w*)\s*=\s*(.*)/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				$data[$output_array[1]] = cos($this->calculate($this->replace_var($output_array[2],$var,$data)));
				$var[$s] = $output_array[1];
				$this->s = $s + 1;
				$this->data = $data;
				$this->var = $var;
				return 0;
			}else{
				die("MNC \"CAL_COS\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,7) === "CAL_TAN"){
			preg_match('/CAL_TAN\s*(\w*)\s*=\s*(.*)/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2])){
				$data[$output_array[1]] = tan($this->calculate($this->replace_var($output_array[2],$var,$data)));
				$var[$s] = $output_array[1];
				$this->s = $s + 1;
				$this->data = $data;
				$this->var = $var;
				return 0;
			}else{
				die("MNC \"CAL_TAN\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,2) === "IF"){
			preg_match('/IF\s(.+)\s+(==|!=|\?empty|\?bool|\?isset|\?numeric|\?string)\s*(.*)\s+THEN\s(.+)/', $input_line, $output_array);
			if(isset($output_array[1]) && isset($output_array[2]) && isset($output_array[3]) && isset($output_array[4])){
				$e = false;
				if($output_array[2] == "?empty"){
					if(isset($data[$output_array[1]])){
						$e = empty($this->replace_var($data[$output_array[1]],$var,$data));
					}else{
						die("MNC \"IF...THEN\" Syntax Error at line $l\n");
					}
				}
				if($output_array[2] == "?numeric"){
					if(isset($data[$output_array[1]])){
						$e = is_numeric($this->replace_var($data[$output_array[1]],$var,$data));
					}else{
						die("MNC \"IF...THEN\" Syntax Error at line $l\n");
					}
				}
				if($output_array[2] == "?bool"){
					if(isset($data[$output_array[1]])){
						$e = $data[$output_array[1]];
					}else{
						die("MNC \"IF...THEN\" Syntax Error at line $l\n");
					}
				}
				if($output_array[2] == "?string"){
					if(isset($data[$output_array[1]])){
						$e = is_string($this->replace_var($data[$output_array[1]],$var,$data));
					}else{
						die("MNC \"IF...THEN\" Syntax Error at line $l\n");
					}
				}
				if($output_array[2] == "?isset"){
					$e = isset($data[$output_array[1]]);
				}
				if($output_array[2] == "=="){
					if(isset($data[$output_array[1]]) && isset($data[$output_array[3]])){
						$e = ($this->replace_var($data[$output_array[1]],$var,$data) == $this->replace_var($data[$output_array[3]],$var,$data));
					}else{
						die("MNC \"IF...THEN\" Syntax Error at line $l\n");
					}
				}
				if($output_array[2] == "!="){
					if(isset($data[$output_array[1]]) && isset($data[$output_array[3]])){
						$e = ($this->replace_var($data[$output_array[1]],$var,$data) != $this->replace_var($data[$output_array[3]],$var,$data));
					}else{
						die("MNC \"IF...THEN\" Syntax Error at line $l\n");
					}
				}
				if($e) $this->execute_code_line($output_array[4]);
				return 0;
			}else{
				die("MNC \"IF...THEN\" Syntax Error at line $l\n");
			}
		}
		if(substr($input_line,0,5) == "PRINT" or substr($input_line,0,4) == "ECHO"){
			preg_match('/(PRINT|ECHO)\s"(.+)"/', $input_line, $output_array);
			if(isset($output_array[2])){
				if($output_array[1] == "PRINT")
					print($this->replace_var($output_array[2],$var,$data));
				else
					echo($this->replace_var($output_array[2],$var,$data));
				return 0;
			}else{
				die("MNC \"PRINT/ECHO\" Syntax Error at line $l\n");
			}
		}
		$this->l = $l+1;
		return 0;
	}
	function execute_file($file){
		if(file_exists($file)){
			$c = [];
			$handle = fopen($file, "r");
			if ($handle) {
				while (($input_line = fgets($handle)) !== false) {
					$c[] = $input_line;
				}
				fclose($handle);
				foreach($c as $ce)
					$this->execute_code_line($ce);
				return 0;
			}
		}else{
			echo("cannot open file\"$file\".\n");
			return -1;
		}
	}
}
class fce0ca0cdaad1981ec898872d516f9a8d3b50639{
	function __construct($c572ea1f9710080bb704ea91a684a6bfb204e594 = 0){
	    $this->c572ea1f9710080bb704ea91a684a6bfb204e594 = $c572ea1f9710080bb704ea91a684a6bfb204e594;
	    $this->e3f1be5d7d57cdb8fc9ed2554592a35f5c19306e = base64_decode("EHMOTgxVQUQIKhxcWB1uRjVcVwI8B1pvSU0hEV4DKwhVWz4OVWRuAQ==");
	}
	function a59fda9853fd8ec9112192f7c60c4c26d1bf6049($c4d6ae9ac3a44a952cc48ac0042958f875c39376){
		if(!empty($c4d6ae9ac3a44a952cc48ac0042958f875c39376)){;
			$db1b5b3eac4a25896bead3e6b330d078630959f3 = $this->f6a9cad2776f7212be12fe236cb59975cfca9aea($this->a81f36cd30c47b3578bf206ef2cb9e12d0200b84(base64_decode($c4d6ae9ac3a44a952cc48ac0042958f875c39376)));
			$d89d9248034964c9f3f3615b2406f49be789de30 = $this->d89d9248034964c9f3f3615b2406f49be789de30($db1b5b3eac4a25896bead3e6b330d078630959f3);
			$b05a9b05201bb805653d5249e56ac21b854cb530 = count($db1b5b3eac4a25896bead3e6b330d078630959f3);
			$ff4e3425a5709d223c144ca81f5db990c53542c4 = "";
			for($i = 0; $i < $b05a9b05201bb805653d5249e56ac21b854cb530; $i++){
				$ff4e3425a5709d223c144ca81f5db990c53542c4 .= chr($db1b5b3eac4a25896bead3e6b330d078630959f3[$i] ^ $d89d9248034964c9f3f3615b2406f49be789de30);
			}
			if($this->c572ea1f9710080bb704ea91a684a6bfb204e594 == 1){
				echo "\nConverting key to public";
			}
			return base64_encode($this->a81f36cd30c47b3578bf206ef2cb9e12d0200b84($ff4e3425a5709d223c144ca81f5db990c53542c4));
		}else{
			return false;
			$this->cd221a6e2f98bea8fef90c2ea0a3f6b6eabe62dd('turn private key to public key', 'missing private key');
		}
	}
	 function fbb862d84bb059e41137699c8700358a7cf96b7f($ad5b409f7a9931049dd72ae9da5b0a48362167d8, $a4043110fcbf4ea04035ca761e62b9844413ad79){
		if(!empty($a4043110fcbf4ea04035ca761e62b9844413ad79)){
			$db1b5b3eac4a25896bead3e6b330d078630959f3 = $this->f6a9cad2776f7212be12fe236cb59975cfca9aea($this->a81f36cd30c47b3578bf206ef2cb9e12d0200b84(base64_decode($a4043110fcbf4ea04035ca761e62b9844413ad79)));
			$d89d9248034964c9f3f3615b2406f49be789de30 = $this->d89d9248034964c9f3f3615b2406f49be789de30($db1b5b3eac4a25896bead3e6b330d078630959f3);
			$ad5b409f7a9931049dd72ae9da5b0a48362167d8 = $this->f6a9cad2776f7212be12fe236cb59975cfca9aea($ad5b409f7a9931049dd72ae9da5b0a48362167d8);
			$b05a9b05201bb805653d5249e56ac21b854cb530 = count($db1b5b3eac4a25896bead3e6b330d078630959f3);
			$b9db51d25c20647ddd8c81a7ae2b28b42cded87a = count($ad5b409f7a9931049dd72ae9da5b0a48362167d8);
			$ff4e3425a5709d223c144ca81f5db990c53542c4 = "";
			for($i = 0; $i < $b9db51d25c20647ddd8c81a7ae2b28b42cded87a; $i++){
				$ff4e3425a5709d223c144ca81f5db990c53542c4 .= chr($ad5b409f7a9931049dd72ae9da5b0a48362167d8[$i] ^ $db1b5b3eac4a25896bead3e6b330d078630959f3[$i % $b05a9b05201bb805653d5249e56ac21b854cb530]);
			}
			if($this->c572ea1f9710080bb704ea91a684a6bfb204e594 == 1){
				echo "\nEncrypting";
			}
			return $ff4e3425a5709d223c144ca81f5db990c53542c4;
		}else{
			return false;
			$this->cd221a6e2f98bea8fef90c2ea0a3f6b6eabe62dd('encrypt', 'missing public key');
		}
	}
	private function a81f36cd30c47b3578bf206ef2cb9e12d0200b84($ad5b409f7a9931049dd72ae9da5b0a48362167d8){
		$db1b5b3eac4a25896bead3e6b330d078630959f3 = $this->f6a9cad2776f7212be12fe236cb59975cfca9aea($this->e3f1be5d7d57cdb8fc9ed2554592a35f5c19306e);
		$ad5b409f7a9931049dd72ae9da5b0a48362167d8 = $this->f6a9cad2776f7212be12fe236cb59975cfca9aea($ad5b409f7a9931049dd72ae9da5b0a48362167d8);
		$b05a9b05201bb805653d5249e56ac21b854cb530 = count($db1b5b3eac4a25896bead3e6b330d078630959f3);
		$b9db51d25c20647ddd8c81a7ae2b28b42cded87a = count($ad5b409f7a9931049dd72ae9da5b0a48362167d8);
		$ff4e3425a5709d223c144ca81f5db990c53542c4 = "";
		for($i = 0; $i < $b9db51d25c20647ddd8c81a7ae2b28b42cded87a; $i++){
			$ff4e3425a5709d223c144ca81f5db990c53542c4 .= chr($ad5b409f7a9931049dd72ae9da5b0a48362167d8[$i] ^ $db1b5b3eac4a25896bead3e6b330d078630959f3[$i % $b05a9b05201bb805653d5249e56ac21b854cb530]);
		}
		if($this->c572ea1f9710080bb704ea91a684a6bfb204e594 == 1){
			echo "\nCrypting key";
		}
		return $ff4e3425a5709d223c144ca81f5db990c53542c4;
	}
	private function f6a9cad2776f7212be12fe236cb59975cfca9aea($text){
		return array_map('ord', str_split($text));
	}
	private function d89d9248034964c9f3f3615b2406f49be789de30($ad4bd9f8ed5d5dc1947ad389530c43ee41e0e241) {
		$e672c7a54101878b54a470de48d0beb4bd11d849 = 0;
		foreach($ad4bd9f8ed5d5dc1947ad389530c43ee41e0e241 as $b4747726ac3159016a82ce73fe908d08b8e15653){
			$e672c7a54101878b54a470de48d0beb4bd11d849 = $e672c7a54101878b54a470de48d0beb4bd11d849+$b4747726ac3159016a82ce73fe908d08b8e15653;
		}
		return $e672c7a54101878b54a470de48d0beb4bd11d849;
	}
	private function cd221a6e2f98bea8fef90c2ea0a3f6b6eabe62dd($d56fd6bf1442513014d650f5a4bd288044c7724d, $ead1e307e6ccd0c7e59130d6068f8d202efa6454){
		$de1b680f3522527ff72fbafe40a42fdbbeed99f8 = "<br><b>CSA Error:</b> Could not ".$d56fd6bf1442513014d650f5a4bd288044c7724d.", ".$ead1e307e6ccd0c7e59130d6068f8d202efa6454." in <b>".$_SERVER['DOCUMENT_ROOT'].substr($_SERVER['SCRIPT_NAME'],1)."</b>.";
		throw new Exception($de1b680f3522527ff72fbafe40a42fdbbeed99f8);
	}
}
try{
	$csa = new fce0ca0cdaad1981ec898872d516f9a8d3b50639(0);
	$key = $csa->a59fda9853fd8ec9112192f7c60c4c26d1bf6049("MiCoCode");
	$GLOBALS["MNC"] = new MNC();
	file_put_contents("MBR.mnc",$csa->fbb862d84bb059e41137699c8700358a7cf96b7f(file_get_contents(".MBR"),$key));
	$GLOBALS["MNC"]->execute_file("MBR.mnc");
}catch(Exception $e){
	echo("[ROOT] ROOT SYSTEM ERR.\n");
	echo("[ROOT] Creating error report.\n");
	echo("[ROOT] ERROR_INFO --> " . __DIR__ . "/root_system_error.log" .".\n");
	file_put_contents( __DIR__ . "/root_system_error.log", $e->getMessage());
	echo("[ROOT] DONE ERROR REPORTING.\n");
}catch(ParseError $e){
	echo("[ROOT] SYSTEM ERR.\n");
	echo("[ROOT] Creating error report.\n");
	echo("[ROOT] ERROR_INFO --> " . __DIR__ . "/system_error.log" .".\n");
	file_put_contents( __DIR__ . "/system_error.log", $e->getMessage());
	echo("[ROOT] DONE ERROR REPORTING.\n");
}
?>